// cpp(meta datanetwork format) source file SrcMeta.cpp generated from diagram SrcMeta
// generated on Sun Apr 03 12:39:18 2005

#include "SrcMeta.h"
#include "UmlExt.h"

#include "UdmStatic.h"

// cross-package metainformation header file
#include "Src2Tgt.h"

namespace SrcMeta {

	Uml::Diagram umldiagram;

	Uml::Class SrcTag1::meta;
	Uml::Class SrcTag::meta;
	Uml::Class SrcPart::meta;
	Uml::Class SrcTag2::meta;
	Uml::Class SrcMain::meta;
	Uml::Class RootFolder::meta;
	Uml::Class MgaObject::meta;
	Uml::Attribute RootFolder::meta_name;
	Uml::Attribute MgaObject::meta_position;
	Uml::Attribute MgaObject::meta_name;
	Uml::CompositionParentRole SrcTag::meta_SrcPart_parent;
	Uml::CompositionParentRole SrcPart::meta_SrcMain_parent;
	Uml::CompositionParentRole SrcMain::meta_RootFolder_parent;
	Uml::CompositionParentRole RootFolder::meta_RootFolder_parent;
	Uml::CompositionChildRole SrcPart::meta_SrcTag_child;
	Uml::CompositionChildRole SrcMain::meta_SrcPart_children;
	Uml::CompositionChildRole RootFolder::meta_RootFolder_children;
	Uml::CompositionChildRole RootFolder::meta_SrcMain_children;
	void Creates()
	{
		SrcTag1::meta = Uml::Class::Create(umldiagram);
		SrcTag::meta = Uml::Class::Create(umldiagram);
		SrcPart::meta = Uml::Class::Create(umldiagram);
		SrcTag2::meta = Uml::Class::Create(umldiagram);
		SrcMain::meta = Uml::Class::Create(umldiagram);
		RootFolder::meta = Uml::Class::Create(umldiagram);
		MgaObject::meta = Uml::Class::Create(umldiagram);
		RootFolder::meta_name = Uml::Attribute::Create(RootFolder::meta);
		MgaObject::meta_position = Uml::Attribute::Create(MgaObject::meta);
		MgaObject::meta_name = Uml::Attribute::Create(MgaObject::meta);
	}
	void InitClassesAttributes()
	{
		SrcTag1::meta.name() = "SrcTag1";
		SrcTag1::meta.isAbstract() = false;
		SrcTag1::meta.stereotype() = "Atom";
		SrcTag::meta.name() = "SrcTag";
		SrcTag::meta.isAbstract() = true;
		SrcTag::meta.stereotype() = "Atom";
		SrcPart::meta.name() = "SrcPart";
		SrcPart::meta.isAbstract() = false;
		SrcPart::meta.stereotype() = "Model";
		SrcTag2::meta.name() = "SrcTag2";
		SrcTag2::meta.isAbstract() = false;
		SrcTag2::meta.stereotype() = "Atom";
		SrcMain::meta.name() = "SrcMain";
		SrcMain::meta.isAbstract() = false;
		SrcMain::meta.stereotype() = "Model";
		RootFolder::meta.name() = "RootFolder";
		RootFolder::meta.isAbstract() = false;
		RootFolder::meta.stereotype() = "Folder";
		MgaObject::meta.name() = "MgaObject";
		MgaObject::meta.isAbstract() = true;
		
		RootFolder::meta_name.name() = "name";
		RootFolder::meta_name.type() = "String";
		RootFolder::meta_name.min() = 0;
		RootFolder::meta_name.max() = 1;
		RootFolder::meta_name.nonpersistent() = false;
		RootFolder::meta_name.registry() = false;
		RootFolder::meta_name.ordered() = false;
		RootFolder::meta_name.visibility() = "public";
		RootFolder::meta_name.defvalue() = vector<string>();
		MgaObject::meta_position.name() = "position";
		MgaObject::meta_position.type() = "String";
		MgaObject::meta_position.min() = 0;
		MgaObject::meta_position.max() = 1;
		MgaObject::meta_position.nonpersistent() = false;
		MgaObject::meta_position.registry() = false;
		MgaObject::meta_position.ordered() = false;
		MgaObject::meta_position.visibility() = "public";
		MgaObject::meta_position.defvalue() = vector<string>();
		MgaObject::meta_name.name() = "name";
		MgaObject::meta_name.type() = "String";
		MgaObject::meta_name.min() = 0;
		MgaObject::meta_name.max() = 1;
		MgaObject::meta_name.nonpersistent() = false;
		MgaObject::meta_name.registry() = false;
		MgaObject::meta_name.ordered() = false;
		MgaObject::meta_name.visibility() = "public";
		MgaObject::meta_name.defvalue() = vector<string>();
		
	}
	void InitComposition0()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		SrcTag::meta_SrcPart_parent = Uml::CompositionParentRole::Create(comp);
		SrcTag::meta_SrcPart_parent.name() = "SrcPart_parent";
		SrcTag::meta_SrcPart_parent.isNavigable() = true;
		SrcTag::meta_SrcPart_parent.target() = SrcPart::meta;
		SrcPart::meta_SrcTag_child = Uml::CompositionChildRole::Create(comp);
		SrcPart::meta_SrcTag_child.name() = "SrcTag";
		SrcPart::meta_SrcTag_child.min() = 0;
		SrcPart::meta_SrcTag_child.max() = 1;
		SrcPart::meta_SrcTag_child.isNavigable() = true;
		SrcPart::meta_SrcTag_child.target() = SrcTag::meta;
	}
	void InitComposition1()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		SrcPart::meta_SrcMain_parent = Uml::CompositionParentRole::Create(comp);
		SrcPart::meta_SrcMain_parent.name() = "SrcMain_parent";
		SrcPart::meta_SrcMain_parent.isNavigable() = true;
		SrcPart::meta_SrcMain_parent.target() = SrcMain::meta;
		SrcMain::meta_SrcPart_children = Uml::CompositionChildRole::Create(comp);
		SrcMain::meta_SrcPart_children.name() = "SrcPart";
		SrcMain::meta_SrcPart_children.min() = 0;
		SrcMain::meta_SrcPart_children.max() = -1;
		SrcMain::meta_SrcPart_children.isNavigable() = true;
		SrcMain::meta_SrcPart_children.target() = SrcPart::meta;
	}
	void InitComposition2()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		SrcMain::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
		SrcMain::meta_RootFolder_parent.name() = "RootFolder_parent";
		SrcMain::meta_RootFolder_parent.isNavigable() = true;
		SrcMain::meta_RootFolder_parent.target() = RootFolder::meta;
		RootFolder::meta_SrcMain_children = Uml::CompositionChildRole::Create(comp);
		RootFolder::meta_SrcMain_children.name() = "SrcMain";
		RootFolder::meta_SrcMain_children.min() = 0;
		RootFolder::meta_SrcMain_children.max() = -1;
		RootFolder::meta_SrcMain_children.isNavigable() = true;
		RootFolder::meta_SrcMain_children.target() = SrcMain::meta;
	}
	void InitComposition3()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		RootFolder::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
		RootFolder::meta_RootFolder_parent.name() = "RootFolder_parent";
		RootFolder::meta_RootFolder_parent.isNavigable() = true;
		RootFolder::meta_RootFolder_parent.target() = RootFolder::meta;
		RootFolder::meta_RootFolder_children = Uml::CompositionChildRole::Create(comp);
		RootFolder::meta_RootFolder_children.name() = "RootFolder";
		RootFolder::meta_RootFolder_children.min() = 0;
		RootFolder::meta_RootFolder_children.max() = -1;
		RootFolder::meta_RootFolder_children.isNavigable() = true;
		RootFolder::meta_RootFolder_children.target() = RootFolder::meta;
	}
	 void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		Uml::Initialize();

		Src2Tgt::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(Uml::diagram);
		meta_dn->CreateNew("SrcMeta.mem", "", Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="SrcMeta";
		umldiagram.version() ="1.00";
		Creates();
		InitClassesAttributes();
		Uml::InitDiagram(umldiagram, "SrcMeta", "1.00");

		InitComposition0();
		InitComposition1();
		InitComposition2();
		InitComposition3();
		SrcTag::meta.subTypes() +=  SrcTag1::meta;
		SrcTag::meta.subTypes() +=  SrcTag2::meta;
		MgaObject::meta.subTypes() +=  SrcTag::meta;
		MgaObject::meta.subTypes() +=  SrcPart::meta;
		MgaObject::meta.subTypes() +=  SrcMain::meta;
		
	}
	void Initialize(const Uml::Diagram & dgr)
	{
		umldiagram = dgr;
		Uml::SetClass(SrcTag1::meta, umldiagram, "SrcTag1");
		Uml::SetClass(SrcTag::meta, umldiagram, "SrcTag");
		Uml::SetClass(SrcPart::meta, umldiagram, "SrcPart");
		Uml::SetClass(SrcTag2::meta, umldiagram, "SrcTag2");
		Uml::SetClass(SrcMain::meta, umldiagram, "SrcMain");
		Uml::SetClass(RootFolder::meta, umldiagram, "RootFolder");
		Uml::SetAttribute(RootFolder::meta_name,RootFolder::meta, "name");
		Uml::SetClass(MgaObject::meta, umldiagram, "MgaObject");
		Uml::SetAttribute(MgaObject::meta_position,MgaObject::meta, "position");
		Uml::SetAttribute(MgaObject::meta_name,MgaObject::meta, "name");
		//composition child roles 
		Uml::SetParentRole(SrcTag::meta_SrcPart_parent,SrcTag::meta,SrcPart::meta, "", "");
		Uml::SetParentRole(SrcPart::meta_SrcMain_parent,SrcPart::meta,SrcMain::meta, "", "");
		Uml::SetParentRole(SrcMain::meta_RootFolder_parent,SrcMain::meta,RootFolder::meta, "", "");
		Uml::SetParentRole(RootFolder::meta_RootFolder_parent,RootFolder::meta,RootFolder::meta, "", "");
		// composition parentroles 
		Uml::SetChildRole(SrcPart::meta_SrcTag_child,SrcPart::meta,SrcTag::meta, "", "");
		Uml::SetChildRole(SrcMain::meta_SrcPart_children,SrcMain::meta,SrcPart::meta, "", "");
		Uml::SetChildRole(RootFolder::meta_RootFolder_children,RootFolder::meta,RootFolder::meta, "", "");
		Uml::SetChildRole(RootFolder::meta_SrcMain_children,RootFolder::meta,SrcMain::meta, "", "");
		// Association roles 







		
	}
	 Udm::UdmDiagram diagram = { &umldiagram, Initialize };
	static struct _regClass
	{
		_regClass()
		{
			Udm::MetaDepository::StoreDiagram("SrcMeta", diagram);
		};
		~_regClass()
		{
			Udm::MetaDepository::RemoveDiagram("SrcMeta");
		};
	} __regUnUsed;

}
// END SrcMeta.cpp
