#ifndef MOBIES_SRCMETA_H
#define MOBIES_SRCMETA_H
// header file SrcMeta.h generated from diagram SrcMeta
// generated on Sun Apr 03 12:39:18 2005

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif



namespace SrcMeta {

	class  SrcTag1;
	class  SrcTag;
	class  SrcPart;
	class  SrcTag2;
	class  SrcMain;
	class  RootFolder;
	class  MgaObject;

	  void Initialize();

	  void Initialize(const Uml::Diagram &dgr);
	extern  Udm::UdmDiagram diagram;

	class  RootFolder :  public Udm::Object {
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : Object(impl) { }
		RootFolder(const RootFolder &master) : Object(master) { }
		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<SrcMeta::RootFolder>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::RootFolder, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::RootFolder> Derived() { return Udm::DerivedAttr<SrcMeta::RootFolder>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::RootFolder, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::RootFolder> Archetype() { return Udm::ArchetypeAttr<SrcMeta::RootFolder>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_RootFolder_children;
		Udm::ChildrenAttr<SrcMeta::RootFolder> RootFolder_children() const { return Udm::ChildrenAttr<SrcMeta::RootFolder>(impl, meta_RootFolder_children); }
		 template <class Pred> Udm::ChildrenAttr<SrcMeta::RootFolder, Pred> RootFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::RootFolder, Pred>(impl, meta_RootFolder_children); }

		static Uml::CompositionChildRole meta_SrcMain_children;
		Udm::ChildrenAttr<SrcMeta::SrcMain> SrcMain_children() const { return Udm::ChildrenAttr<SrcMeta::SrcMain>(impl, meta_SrcMain_children); }
		 template <class Pred> Udm::ChildrenAttr<SrcMeta::SrcMain, Pred> SrcMain_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcMain, Pred>(impl, meta_SrcMain_children); }

		Udm::ChildrenAttr<SrcMeta::SrcMain> SrcMain_kind_children() const { return Udm::ChildrenAttr<SrcMeta::SrcMain>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::SrcMain, Pred> SrcMain_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcMain, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SrcMeta::RootFolder> RootFolder_kind_children() const { return Udm::ChildrenAttr<SrcMeta::RootFolder>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::RootFolder, Pred> RootFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::RootFolder, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SrcMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<SrcMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<SrcMeta::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<SrcMeta::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<SrcMeta::RootFolder> parent() const { return Udm::ParentAttr<SrcMeta::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  MgaObject :  public Udm::Object {
	 public:
		static Uml::Class meta;

		MgaObject() { }
		MgaObject(Udm::ObjectImpl *impl) : Object(impl) { }
		MgaObject(const MgaObject &master) : Object(master) { }
		static MgaObject Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static MgaObject Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		MgaObject CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		MgaObject CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<MgaObject> Instances() { return Udm::InstantiatedAttr<SrcMeta::MgaObject>(impl);}
		template <class Pred> Udm::InstantiatedAttr<MgaObject, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::MgaObject, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::MgaObject> Derived() { return Udm::DerivedAttr<SrcMeta::MgaObject>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::MgaObject, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::MgaObject, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::MgaObject> Archetype() { return Udm::ArchetypeAttr<SrcMeta::MgaObject>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  SrcTag :  public MgaObject {
	 public:
		static Uml::Class meta;

		SrcTag() { }
		SrcTag(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		SrcTag(const SrcTag &master) : MgaObject(master) { }
		static SrcTag Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static SrcTag Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SrcTag CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SrcTag CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SrcTag> Instances() { return Udm::InstantiatedAttr<SrcMeta::SrcTag>(impl);}
		template <class Pred> Udm::InstantiatedAttr<SrcTag, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::SrcTag, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::SrcTag> Derived() { return Udm::DerivedAttr<SrcMeta::SrcTag>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::SrcTag, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::SrcTag, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::SrcTag> Archetype() { return Udm::ArchetypeAttr<SrcMeta::SrcTag>(impl);}

		static Uml::CompositionParentRole meta_SrcPart_parent;
		Udm::ParentAttr<SrcMeta::SrcPart> SrcPart_parent() const { return Udm::ParentAttr<SrcMeta::SrcPart>(impl, meta_SrcPart_parent); }

		Udm::ParentAttr<SrcMeta::MgaObject> parent() const { return Udm::ParentAttr<SrcMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  SrcTag1 :  public SrcTag {
	 public:
		static Uml::Class meta;

		SrcTag1() { }
		SrcTag1(Udm::ObjectImpl *impl) : SrcTag(impl) { }
		SrcTag1(const SrcTag1 &master) : SrcTag(master) { }
		static SrcTag1 Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static SrcTag1 Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SrcTag1 CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SrcTag1 CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SrcTag1> Instances() { return Udm::InstantiatedAttr<SrcMeta::SrcTag1>(impl);}
		template <class Pred> Udm::InstantiatedAttr<SrcTag1, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::SrcTag1, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::SrcTag1> Derived() { return Udm::DerivedAttr<SrcMeta::SrcTag1>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::SrcTag1, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::SrcTag1, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::SrcTag1> Archetype() { return Udm::ArchetypeAttr<SrcMeta::SrcTag1>(impl);}

		Udm::ParentAttr<SrcMeta::MgaObject> parent() const { return Udm::ParentAttr<SrcMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  SrcPart :  public MgaObject {
	 public:
		static Uml::Class meta;

		SrcPart() { }
		SrcPart(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		SrcPart(const SrcPart &master) : MgaObject(master) { }
		static SrcPart Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static SrcPart Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SrcPart CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SrcPart CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SrcPart> Instances() { return Udm::InstantiatedAttr<SrcMeta::SrcPart>(impl);}
		template <class Pred> Udm::InstantiatedAttr<SrcPart, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::SrcPart, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::SrcPart> Derived() { return Udm::DerivedAttr<SrcMeta::SrcPart>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::SrcPart, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::SrcPart, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::SrcPart> Archetype() { return Udm::ArchetypeAttr<SrcMeta::SrcPart>(impl);}

		static Uml::CompositionChildRole meta_SrcTag_child;
		Udm::ChildAttr<SrcMeta::SrcTag> SrcTag_child() const { return Udm::ChildAttr<SrcMeta::SrcTag>(impl, meta_SrcTag_child); }

		Udm::ChildrenAttr<SrcMeta::SrcTag1> SrcTag1_kind_children() const { return Udm::ChildrenAttr<SrcMeta::SrcTag1>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::SrcTag1, Pred> SrcTag1_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcTag1, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SrcMeta::SrcTag> SrcTag_kind_children() const { return Udm::ChildrenAttr<SrcMeta::SrcTag>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::SrcTag, Pred> SrcTag_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcTag, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SrcMeta::SrcTag2> SrcTag2_kind_children() const { return Udm::ChildrenAttr<SrcMeta::SrcTag2>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::SrcTag2, Pred> SrcTag2_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcTag2, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SrcMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<SrcMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_SrcMain_parent;
		Udm::ParentAttr<SrcMeta::SrcMain> SrcMain_parent() const { return Udm::ParentAttr<SrcMeta::SrcMain>(impl, meta_SrcMain_parent); }

		Udm::ParentAttr<SrcMeta::MgaObject> parent() const { return Udm::ParentAttr<SrcMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  SrcTag2 :  public SrcTag {
	 public:
		static Uml::Class meta;

		SrcTag2() { }
		SrcTag2(Udm::ObjectImpl *impl) : SrcTag(impl) { }
		SrcTag2(const SrcTag2 &master) : SrcTag(master) { }
		static SrcTag2 Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static SrcTag2 Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SrcTag2 CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SrcTag2 CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SrcTag2> Instances() { return Udm::InstantiatedAttr<SrcMeta::SrcTag2>(impl);}
		template <class Pred> Udm::InstantiatedAttr<SrcTag2, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::SrcTag2, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::SrcTag2> Derived() { return Udm::DerivedAttr<SrcMeta::SrcTag2>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::SrcTag2, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::SrcTag2, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::SrcTag2> Archetype() { return Udm::ArchetypeAttr<SrcMeta::SrcTag2>(impl);}

		Udm::ParentAttr<SrcMeta::MgaObject> parent() const { return Udm::ParentAttr<SrcMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  SrcMain :  public MgaObject {
	 public:
		static Uml::Class meta;

		SrcMain() { }
		SrcMain(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		SrcMain(const SrcMain &master) : MgaObject(master) { }
		static SrcMain Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static SrcMain Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SrcMain CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SrcMain CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SrcMain> Instances() { return Udm::InstantiatedAttr<SrcMeta::SrcMain>(impl);}
		template <class Pred> Udm::InstantiatedAttr<SrcMain, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SrcMeta::SrcMain, Pred>(impl);}

		Udm::DerivedAttr<SrcMeta::SrcMain> Derived() { return Udm::DerivedAttr<SrcMeta::SrcMain>(impl);}
		template <class Pred> Udm::DerivedAttr<SrcMeta::SrcMain, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SrcMeta::SrcMain, Pred>(impl);}

		Udm::ArchetypeAttr<SrcMeta::SrcMain> Archetype() { return Udm::ArchetypeAttr<SrcMeta::SrcMain>(impl);}

		static Uml::CompositionChildRole meta_SrcPart_children;
		Udm::ChildrenAttr<SrcMeta::SrcPart> SrcPart_children() const { return Udm::ChildrenAttr<SrcMeta::SrcPart>(impl, meta_SrcPart_children); }
		 template <class Pred> Udm::ChildrenAttr<SrcMeta::SrcPart, Pred> SrcPart_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcPart, Pred>(impl, meta_SrcPart_children); }

		Udm::ChildrenAttr<SrcMeta::SrcPart> SrcPart_kind_children() const { return Udm::ChildrenAttr<SrcMeta::SrcPart>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::SrcPart, Pred> SrcPart_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::SrcPart, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SrcMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<SrcMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SrcMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SrcMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<SrcMeta::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<SrcMeta::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<SrcMeta::RootFolder> parent() const { return Udm::ParentAttr<SrcMeta::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_SRCMETA_H
