#ifndef MOBIES_TGTMETA_H
#define MOBIES_TGTMETA_H
// header file TgtMeta.h generated from diagram TgtMeta
// generated on Sun Apr 03 12:39:18 2005

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif



namespace TgtMeta {

	class  Type2Ref;
	class  Type1Ref;
	class  TgtType2;
	class  TgtPart2;
	class  TgtPart1;
	class  TgtType1;
	class  TgtDataStore;
	class  TgtTypeSystem;
	class  TgtMain;
	class  RootFolder;
	class  MgaObject;

	  void Initialize();

	  void Initialize(const Uml::Diagram &dgr);
	extern  Udm::UdmDiagram diagram;

	class  RootFolder :  public Udm::Object {
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : Object(impl) { }
		RootFolder(const RootFolder &master) : Object(master) { }
		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<TgtMeta::RootFolder>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::RootFolder, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::RootFolder> Derived() { return Udm::DerivedAttr<TgtMeta::RootFolder>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::RootFolder, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::RootFolder> Archetype() { return Udm::ArchetypeAttr<TgtMeta::RootFolder>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_RootFolder_children;
		Udm::ChildrenAttr<TgtMeta::RootFolder> RootFolder_children() const { return Udm::ChildrenAttr<TgtMeta::RootFolder>(impl, meta_RootFolder_children); }
		 template <class Pred> Udm::ChildrenAttr<TgtMeta::RootFolder, Pred> RootFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::RootFolder, Pred>(impl, meta_RootFolder_children); }

		static Uml::CompositionChildRole meta_TgtMain_children;
		Udm::ChildrenAttr<TgtMeta::TgtMain> TgtMain_children() const { return Udm::ChildrenAttr<TgtMeta::TgtMain>(impl, meta_TgtMain_children); }
		 template <class Pred> Udm::ChildrenAttr<TgtMeta::TgtMain, Pred> TgtMain_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtMain, Pred>(impl, meta_TgtMain_children); }

		Udm::ChildrenAttr<TgtMeta::TgtMain> TgtMain_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtMain>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtMain, Pred> TgtMain_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtMain, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::RootFolder> RootFolder_kind_children() const { return Udm::ChildrenAttr<TgtMeta::RootFolder>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::RootFolder, Pred> RootFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::RootFolder, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<TgtMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<TgtMeta::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<TgtMeta::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<TgtMeta::RootFolder> parent() const { return Udm::ParentAttr<TgtMeta::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  MgaObject :  public Udm::Object {
	 public:
		static Uml::Class meta;

		MgaObject() { }
		MgaObject(Udm::ObjectImpl *impl) : Object(impl) { }
		MgaObject(const MgaObject &master) : Object(master) { }
		static MgaObject Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static MgaObject Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		MgaObject CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		MgaObject CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<MgaObject> Instances() { return Udm::InstantiatedAttr<TgtMeta::MgaObject>(impl);}
		template <class Pred> Udm::InstantiatedAttr<MgaObject, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::MgaObject, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::MgaObject> Derived() { return Udm::DerivedAttr<TgtMeta::MgaObject>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::MgaObject, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::MgaObject, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::MgaObject> Archetype() { return Udm::ArchetypeAttr<TgtMeta::MgaObject>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Type2Ref :  public MgaObject {
	 public:
		static Uml::Class meta;

		Type2Ref() { }
		Type2Ref(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Type2Ref(const Type2Ref &master) : MgaObject(master) { }
		static Type2Ref Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Type2Ref Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Type2Ref CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Type2Ref CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Type2Ref> Instances() { return Udm::InstantiatedAttr<TgtMeta::Type2Ref>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Type2Ref, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::Type2Ref, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::Type2Ref> Derived() { return Udm::DerivedAttr<TgtMeta::Type2Ref>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::Type2Ref, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::Type2Ref, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::Type2Ref> Archetype() { return Udm::ArchetypeAttr<TgtMeta::Type2Ref>(impl);}

		static Uml::AssociationRole meta_ref;
		Udm::PointerAttr<TgtMeta::TgtType2> ref() const { return Udm::PointerAttr<TgtMeta::TgtType2>(impl, meta_ref); }

		static Uml::CompositionParentRole meta_TgtPart2_parent;
		Udm::ParentAttr<TgtMeta::TgtPart2> TgtPart2_parent() const { return Udm::ParentAttr<TgtMeta::TgtPart2>(impl, meta_TgtPart2_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  Type1Ref :  public MgaObject {
	 public:
		static Uml::Class meta;

		Type1Ref() { }
		Type1Ref(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Type1Ref(const Type1Ref &master) : MgaObject(master) { }
		static Type1Ref Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Type1Ref Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Type1Ref CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Type1Ref CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Type1Ref> Instances() { return Udm::InstantiatedAttr<TgtMeta::Type1Ref>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Type1Ref, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::Type1Ref, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::Type1Ref> Derived() { return Udm::DerivedAttr<TgtMeta::Type1Ref>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::Type1Ref, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::Type1Ref, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::Type1Ref> Archetype() { return Udm::ArchetypeAttr<TgtMeta::Type1Ref>(impl);}

		static Uml::AssociationRole meta_ref;
		Udm::PointerAttr<TgtMeta::TgtType1> ref() const { return Udm::PointerAttr<TgtMeta::TgtType1>(impl, meta_ref); }

		static Uml::CompositionParentRole meta_TgtPart1_parent;
		Udm::ParentAttr<TgtMeta::TgtPart1> TgtPart1_parent() const { return Udm::ParentAttr<TgtMeta::TgtPart1>(impl, meta_TgtPart1_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtType2 :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtType2() { }
		TgtType2(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtType2(const TgtType2 &master) : MgaObject(master) { }
		static TgtType2 Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtType2 Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtType2 CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtType2 CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtType2> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtType2>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtType2, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtType2, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtType2> Derived() { return Udm::DerivedAttr<TgtMeta::TgtType2>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtType2, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtType2, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtType2> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtType2>(impl);}

		static Uml::AssociationRole meta_referedbyType2Ref;
		Udm::AssocAttr<TgtMeta::Type2Ref> referedbyType2Ref() const { return Udm::AssocAttr<TgtMeta::Type2Ref>(impl, meta_referedbyType2Ref); }
		template <class Pred> Udm::AssocAttr<TgtMeta::Type2Ref, Pred > referedbyType2Ref_sorted(const Pred &) const { return Udm::AssocAttr<TgtMeta::Type2Ref, Pred>(impl, meta_referedbyType2Ref); }

		static Uml::CompositionParentRole meta_TgtTypeSystem_parent;
		Udm::ParentAttr<TgtMeta::TgtTypeSystem> TgtTypeSystem_parent() const { return Udm::ParentAttr<TgtMeta::TgtTypeSystem>(impl, meta_TgtTypeSystem_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtPart2 :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtPart2() { }
		TgtPart2(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtPart2(const TgtPart2 &master) : MgaObject(master) { }
		static TgtPart2 Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtPart2 Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtPart2 CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtPart2 CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtPart2> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtPart2>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtPart2, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtPart2, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtPart2> Derived() { return Udm::DerivedAttr<TgtMeta::TgtPart2>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtPart2, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtPart2, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtPart2> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtPart2>(impl);}

		static Uml::CompositionChildRole meta_Type2Ref_child;
		Udm::ChildAttr<TgtMeta::Type2Ref> Type2Ref_child() const { return Udm::ChildAttr<TgtMeta::Type2Ref>(impl, meta_Type2Ref_child); }

		Udm::ChildrenAttr<TgtMeta::Type2Ref> Type2Ref_kind_children() const { return Udm::ChildrenAttr<TgtMeta::Type2Ref>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::Type2Ref, Pred> Type2Ref_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::Type2Ref, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<TgtMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_TgtDataStore_parent;
		Udm::ParentAttr<TgtMeta::TgtDataStore> TgtDataStore_parent() const { return Udm::ParentAttr<TgtMeta::TgtDataStore>(impl, meta_TgtDataStore_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtPart1 :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtPart1() { }
		TgtPart1(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtPart1(const TgtPart1 &master) : MgaObject(master) { }
		static TgtPart1 Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtPart1 Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtPart1 CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtPart1 CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtPart1> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtPart1>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtPart1, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtPart1, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtPart1> Derived() { return Udm::DerivedAttr<TgtMeta::TgtPart1>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtPart1, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtPart1, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtPart1> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtPart1>(impl);}

		static Uml::CompositionChildRole meta_Type1Ref_child;
		Udm::ChildAttr<TgtMeta::Type1Ref> Type1Ref_child() const { return Udm::ChildAttr<TgtMeta::Type1Ref>(impl, meta_Type1Ref_child); }

		Udm::ChildrenAttr<TgtMeta::Type1Ref> Type1Ref_kind_children() const { return Udm::ChildrenAttr<TgtMeta::Type1Ref>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::Type1Ref, Pred> Type1Ref_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::Type1Ref, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<TgtMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_TgtDataStore_parent;
		Udm::ParentAttr<TgtMeta::TgtDataStore> TgtDataStore_parent() const { return Udm::ParentAttr<TgtMeta::TgtDataStore>(impl, meta_TgtDataStore_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtType1 :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtType1() { }
		TgtType1(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtType1(const TgtType1 &master) : MgaObject(master) { }
		static TgtType1 Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtType1 Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtType1 CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtType1 CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtType1> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtType1>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtType1, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtType1, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtType1> Derived() { return Udm::DerivedAttr<TgtMeta::TgtType1>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtType1, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtType1, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtType1> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtType1>(impl);}

		static Uml::AssociationRole meta_referedbyType1Ref;
		Udm::AssocAttr<TgtMeta::Type1Ref> referedbyType1Ref() const { return Udm::AssocAttr<TgtMeta::Type1Ref>(impl, meta_referedbyType1Ref); }
		template <class Pred> Udm::AssocAttr<TgtMeta::Type1Ref, Pred > referedbyType1Ref_sorted(const Pred &) const { return Udm::AssocAttr<TgtMeta::Type1Ref, Pred>(impl, meta_referedbyType1Ref); }

		static Uml::CompositionParentRole meta_TgtTypeSystem_parent;
		Udm::ParentAttr<TgtMeta::TgtTypeSystem> TgtTypeSystem_parent() const { return Udm::ParentAttr<TgtMeta::TgtTypeSystem>(impl, meta_TgtTypeSystem_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtDataStore :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtDataStore() { }
		TgtDataStore(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtDataStore(const TgtDataStore &master) : MgaObject(master) { }
		static TgtDataStore Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtDataStore Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtDataStore CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtDataStore CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtDataStore> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtDataStore>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtDataStore, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtDataStore, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtDataStore> Derived() { return Udm::DerivedAttr<TgtMeta::TgtDataStore>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtDataStore, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtDataStore, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtDataStore> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtDataStore>(impl);}

		static Uml::CompositionChildRole meta_TgtPart1_child;
		Udm::ChildAttr<TgtMeta::TgtPart1> TgtPart1_child() const { return Udm::ChildAttr<TgtMeta::TgtPart1>(impl, meta_TgtPart1_child); }

		static Uml::CompositionChildRole meta_TgtPart2_children;
		Udm::ChildrenAttr<TgtMeta::TgtPart2> TgtPart2_children() const { return Udm::ChildrenAttr<TgtMeta::TgtPart2>(impl, meta_TgtPart2_children); }
		 template <class Pred> Udm::ChildrenAttr<TgtMeta::TgtPart2, Pred> TgtPart2_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtPart2, Pred>(impl, meta_TgtPart2_children); }

		Udm::ChildrenAttr<TgtMeta::TgtPart2> TgtPart2_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtPart2>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtPart2, Pred> TgtPart2_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtPart2, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::TgtPart1> TgtPart1_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtPart1>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtPart1, Pred> TgtPart1_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtPart1, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<TgtMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_TgtMain_parent;
		Udm::ParentAttr<TgtMeta::TgtMain> TgtMain_parent() const { return Udm::ParentAttr<TgtMeta::TgtMain>(impl, meta_TgtMain_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtTypeSystem :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtTypeSystem() { }
		TgtTypeSystem(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtTypeSystem(const TgtTypeSystem &master) : MgaObject(master) { }
		static TgtTypeSystem Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtTypeSystem Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtTypeSystem CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtTypeSystem CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtTypeSystem> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtTypeSystem>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtTypeSystem, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtTypeSystem, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtTypeSystem> Derived() { return Udm::DerivedAttr<TgtMeta::TgtTypeSystem>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtTypeSystem, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtTypeSystem, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtTypeSystem> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtTypeSystem>(impl);}

		static Uml::CompositionChildRole meta_TgtType1_child;
		Udm::ChildAttr<TgtMeta::TgtType1> TgtType1_child() const { return Udm::ChildAttr<TgtMeta::TgtType1>(impl, meta_TgtType1_child); }

		static Uml::CompositionChildRole meta_TgtType2_child;
		Udm::ChildAttr<TgtMeta::TgtType2> TgtType2_child() const { return Udm::ChildAttr<TgtMeta::TgtType2>(impl, meta_TgtType2_child); }

		Udm::ChildrenAttr<TgtMeta::TgtType2> TgtType2_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtType2>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtType2, Pred> TgtType2_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtType2, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::TgtType1> TgtType1_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtType1>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtType1, Pred> TgtType1_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtType1, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<TgtMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_TgtMain_parent;
		Udm::ParentAttr<TgtMeta::TgtMain> TgtMain_parent() const { return Udm::ParentAttr<TgtMeta::TgtMain>(impl, meta_TgtMain_parent); }

		Udm::ParentAttr<TgtMeta::MgaObject> parent() const { return Udm::ParentAttr<TgtMeta::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  TgtMain :  public MgaObject {
	 public:
		static Uml::Class meta;

		TgtMain() { }
		TgtMain(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		TgtMain(const TgtMain &master) : MgaObject(master) { }
		static TgtMain Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static TgtMain Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TgtMain CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TgtMain CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TgtMain> Instances() { return Udm::InstantiatedAttr<TgtMeta::TgtMain>(impl);}
		template <class Pred> Udm::InstantiatedAttr<TgtMain, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TgtMeta::TgtMain, Pred>(impl);}

		Udm::DerivedAttr<TgtMeta::TgtMain> Derived() { return Udm::DerivedAttr<TgtMeta::TgtMain>(impl);}
		template <class Pred> Udm::DerivedAttr<TgtMeta::TgtMain, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TgtMeta::TgtMain, Pred>(impl);}

		Udm::ArchetypeAttr<TgtMeta::TgtMain> Archetype() { return Udm::ArchetypeAttr<TgtMeta::TgtMain>(impl);}

		static Uml::CompositionChildRole meta_TgtDataStore_child;
		Udm::ChildAttr<TgtMeta::TgtDataStore> TgtDataStore_child() const { return Udm::ChildAttr<TgtMeta::TgtDataStore>(impl, meta_TgtDataStore_child); }

		static Uml::CompositionChildRole meta_TgtTypeSystem_child;
		Udm::ChildAttr<TgtMeta::TgtTypeSystem> TgtTypeSystem_child() const { return Udm::ChildAttr<TgtMeta::TgtTypeSystem>(impl, meta_TgtTypeSystem_child); }

		Udm::ChildrenAttr<TgtMeta::TgtDataStore> TgtDataStore_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtDataStore>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtDataStore, Pred> TgtDataStore_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtDataStore, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::TgtTypeSystem> TgtTypeSystem_kind_children() const { return Udm::ChildrenAttr<TgtMeta::TgtTypeSystem>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::TgtTypeSystem, Pred> TgtTypeSystem_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::TgtTypeSystem, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<TgtMeta::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<TgtMeta::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<TgtMeta::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<TgtMeta::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<TgtMeta::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<TgtMeta::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<TgtMeta::RootFolder> parent() const { return Udm::ParentAttr<TgtMeta::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_TGTMETA_H
